Alexandria is a library of useful code and various APIs with the intention of simplifying the mod creation process via it's use as a dependency.

## Featured APIs

## cAPI

- An API for making hats.
- Idk someones gonna have to fill me in on this

### CharacterAPI
An API for fully customizable custom characters, allowing features present in basegame characters such as:
- Alternate skins
- Alt weapons
- Custom Pasts (You still have to make the Past yourself)
- Glow / Emissive Shader support.
- Custom Icons on character select screen.
- Custom animations.
- Prebaked Sprite Collection and Animation support.
- Hegemony Credit Cost.
- Custom Ghost Interaction
- ..And more

---
### DungeonAPI
An API used for loading and generating Custom Rooms made with [Room Architect Tool](https://thunderstore.io/c/enter-the-gungeon/p/Alexandria/RoomArchitectTool/).     
Has tools for:
-  Override alt floor Master Rounds.
-  Loading custom room/s from embedded file or mod folder

Also contains a static list of nearly every gameobject used in rooms in the game in class "SetupExoticObjects".

---
### EnemyAPI
Tools for making custom enemies, and other enemy related tools.     
Includes:
- EnemyBuilder
- BossBuilder
- EnemyBuildingTools (A class with misceallaneuous methods for enemy creation)
- AIActorUtility (A class with misceallaneuous methods for enemy related stuff)
- AttackBehaviourUtility (Helper class related to enemy behaviors)

---
### ShopAPI
API for creating Shop-Type NPCs.        
Allows for:
- Custom Costs.
- Custom dialogue
- Minimap Icons
- Price Multipliers
- Rainbow Mode immunity
- Modified Loot Table Selection
- Appear with chance in the Main Shop.
- Custom Item positions
- ...And more.

---
### PrefabAPI
Allows for creation of true custom prefabs.

---
### ItemAPI
An API for the creation of custom items  / guns.


---
### TranslationAPI
An API for custom translations of modded text.


---
### BreakableAPI
A collection of methods for creating various objects like debris, pots and other types of breakable decorative objects.

---
### ChestAPI
WIP

## Featured Misc. Tools

- Assetbundle tools (creating custom stuff with prebaked sprite collections and animations.)
- A static list of every enemies GUID for convenience.
- Various helpful debug commands.
- Custom Stat API (Need to actually look at how it works)
- At least a dozen more related classes that are somewhat helpful/
